<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 https://maven.apache.org/xsd/maven-4.0.0.xsd">
  <modelVersion>4.0.0</modelVersion>
  <groupId>api.sicredi</groupId>
  <artifactId>api.sicredi</artifactId>
  <version>0.0.1-SNAPSHOT</version>
  
  <properties>
     <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
	<java.version>20</java.version>
	<compiler.plugin.version>3.10.1</compiler.plugin.version>
    <jackson.version>2.15.2</jackson.version>
    <faker.version>1.0.2</faker.version>
    <lombok.version>1.18.28</lombok.version>
    <restassured.version>5.3.1</restassured.version>
    <wiremock.version>2.33.2</wiremock.version>
    <allure.junit5.version>2.18.1</allure.junit5.version>
	<allure.maven.plugin.version>2.11.2</allure.maven.plugin.version>
	<allure.reports.version>2.18.1</allure.reports.version>
	<aspectj.version>1.9.9.1</aspectj.version>
	<surefire.plugin.version>3.0.0-M7</surefire.plugin.version>
	<slf4j.version>1.7.36</slf4j.version>
  </properties>

  <dependencies>
   <!-- https://mvnrepository.com/artifact/org.junit.jupiter/junit-jupiter-engine -->
	<dependency>
	    <groupId>org.junit.jupiter</groupId>
	    <artifactId>junit-jupiter-engine</artifactId>
	    <version>5.9.3</version>
	    <scope>test</scope>
	</dependency>
	
	<!-- https://mvnrepository.com/artifact/io.rest-assured/rest-assured -->
	<dependency>
	    <groupId>io.rest-assured</groupId>
	    <artifactId>rest-assured</artifactId>
	    <version>${restassured.version}</version>
	    <scope>test</scope>
	</dependency>

	<!-- https://mvnrepository.com/artifact/org.apache.commons/commons-text -->
	<dependency>
	    <groupId>org.apache.commons</groupId>
	    <artifactId>commons-text</artifactId>
	    <version>1.10.0</version>
	</dependency>

	<dependency>
		<groupId>io.rest-assured</groupId>
		<artifactId>json-schema-validator</artifactId>
		<version>${restassured.version}</version>
		<scope>test</scope>
	</dependency>
	
	<dependency>
		<groupId>com.fasterxml.jackson.core</groupId>
		<artifactId>jackson-core</artifactId>
		<version>${jackson.version}</version>
		<scope>test</scope>
	</dependency>
	
	<dependency>
		<groupId>com.fasterxml.jackson.core</groupId>
		<artifactId>jackson-databind</artifactId>
		<version>${jackson.version}</version>
		<scope>test</scope>
	</dependency>
	
	<dependency>
		<groupId>com.github.javafaker</groupId>
		<artifactId>javafaker</artifactId>
		<version>${faker.version}</version>
		<scope>test</scope>
	</dependency>
	
	<dependency>
		<groupId>org.projectlombok</groupId>
		<artifactId>lombok</artifactId>
		<version>${lombok.version}</version>
		<scope>provided</scope>
	</dependency>
	
	<dependency>
		<groupId>com.github.tomakehurst</groupId>
		<artifactId>wiremock-jre8</artifactId>
		<version>${wiremock.version}</version>
		<scope>test</scope>
	</dependency>
	
	<dependency>
		<groupId>io.qameta.allure</groupId>
		<artifactId>allure-junit5</artifactId>
		<version>${allure.junit5.version}</version>
		<scope>test</scope>
	</dependency>
	
	<dependency>
		<groupId>org.slf4j</groupId>
		<artifactId>slf4j-api</artifactId>
		<version>${slf4j.version}</version>
		<scope>test</scope>
	</dependency>

	<dependency>
		<groupId>org.slf4j</groupId>
		<artifactId>slf4j-simple</artifactId>
		<version>${slf4j.version}</version>
		<scope>test</scope>
	</dependency>
  </dependencies>
  
  <build>
    <pluginManagement><!-- lock down plugins versions to avoid using Maven defaults (may be moved to parent pom) -->
      <plugins>
        <!-- clean lifecycle, see https://maven.apache.org/ref/current/maven-core/lifecycles.html#clean_Lifecycle -->
        <plugin>
			<groupId>org.apache.maven.plugins</groupId>
			<artifactId>maven-compiler-plugin</artifactId>
			<version>${compiler.plugin.version}</version>
			<configuration>
				<encoding>UTF-8</encoding>
				<source>${java.version}</source>
				<target>${java.version}</target>
			</configuration>
		</plugin>
        <plugin>
          <artifactId>maven-clean-plugin</artifactId>
          <version>3.1.0</version>
        </plugin>
        <!-- default lifecycle, jar packaging: see https://maven.apache.org/ref/current/maven-core/default-bindings.html#Plugin_bindings_for_jar_packaging -->
        <plugin>
          <artifactId>maven-resources-plugin</artifactId>
          <version>3.0.2</version>
        </plugin>
        <plugin>
          <artifactId>maven-jar-plugin</artifactId>
          <version>3.0.2</version>
        </plugin>
        <plugin>
          <artifactId>maven-install-plugin</artifactId>
          <version>2.5.2</version>
        </plugin>
        <plugin>
          <artifactId>maven-deploy-plugin</artifactId>
          <version>2.8.2</version>
        </plugin>
        <!-- site lifecycle, see https://maven.apache.org/ref/current/maven-core/lifecycles.html#site_Lifecycle -->
        <plugin>
          <artifactId>maven-site-plugin</artifactId>
          <version>3.7.1</version>
        </plugin>
        <plugin>
          <artifactId>maven-project-info-reports-plugin</artifactId>
          <version>3.0.0</version>
        </plugin>
        
        <plugin>
			<groupId>org.apache.maven.plugins</groupId>
			<artifactId>maven-surefire-plugin</artifactId>
			<version>${surefire.plugin.version}</version>
			<configuration>
				<testFailureIgnore>false</testFailureIgnore>
				<argLine>
				    -javaagent:"${settings.localRepository}/org/aspectj/aspectjweaver/${aspectj.version}/aspectjweaver-${aspectj.version}.jar"
				</argLine>
				<systemProperties>
					<property>
						<name>allure.results.directory</name>
						<value>${project.build.directory}/allure-results</value>
					</property>
					<property>
						<name>junit.jupiter.extensions.autodetection.enabled</name>
						<value>true</value>
					</property>
				</systemProperties>
			</configuration>
			<dependencies>
				<dependency>
					<groupId>org.aspectj</groupId>
					<artifactId>aspectjweaver</artifactId>
					<version>${aspectj.version}</version>
				</dependency>
			</dependencies>
		</plugin>
		
		<plugin>
			<groupId>io.qameta.allure</groupId>
			<artifactId>allure-maven</artifactId>
			<version>${allure.maven.plugin.version}</version>
			<configuration>
                <reportVersion>${allure.reports.version}</reportVersion>
                <allureDownloadUrl>
                	https://github.com/allure-framework/allure2/releases/download/%s/allure-%s.zip
            	</allureDownloadUrl>
            	<resultsDirectory>${project.build.directory}/allure-results</resultsDirectory>
            	<reportDirectory>${project.build.directory}/allure-reports</reportDirectory>
            </configuration>
		</plugin>
		
      </plugins>
    </pluginManagement>
  </build>
</project>